#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

int main () {
  char command[255];
  char seps[] = " \t";
  char *part;
  char *args[10];
  short no_args;
  int status, pid, wpid;

  while (1) {
    printf ("spsh$ ");
    fgets (command, sizeof(command), stdin);
    // Aus Eingabe \n abschneiden
    command[strlen(command)-1] = (char) 0;

    no_args = 0;
    
    part = strtok (command, seps);
    while ( part != NULL ) {
      args[no_args] = part;
      no_args++;
      part = strtok (NULL, seps);
    };

    if (no_args == 0) continue;  // kein fork/exec

    // internes Kommando?
    if (!strcmp(args[0],"exit")) {
      printf ("Terminating\n");
      exit(0);
    };
    
    // Kommando mit exec ausfuehren
    args[no_args] = NULL;

    pid = fork();
    if ( pid == 0 ) {
      // Kindprozess
      execvp (args[0], args);
      // exec fehlgeschlagen?
      printf ("%s not found\n", args[0]);
      exit(0);
    } else {
      // Vaterprozess
      waitpid (pid, &status, 0);
    };
  }
}

